function [lab_pfile] = preprocessing_sbac(dat_pfile,src_list_file,sr,mapping,b2,a2,t2)
% calculate SBPCA feature for list of audio files 
% [2012-07-22] Byung Suk Lee bsl@ee.columbia.edu
addpath('../audioread/');

nchs = length(mapping);
kdim = size(mapping{1},2);
pf_create = 'pfile_create';

%% Make all source file list
if ~exist(dat_pfile,'file')
asciiname = [dat_pfile,'.asc'];
ascpart = [asciiname,'.part'];
if exist(dat_pfile,'file'), delete(dat_pfile); end;
if exist(asciiname,'file'), delete(asciiname); end;
isen = 0;
fid = fopen(src_list_file,'r');
while 1
    line = fgetl(fid);
    if ~ischar(line), break, end
    files = regexp(line,',','split');
    disp(files{1})
    [isen] = sub_pre_sbac(files{1},asciiname,ascpart,isen,sr,mapping,b2,a2,t2);
end
fclose(fid);

%% create pfile from the ascii files
nf = nchs * kdim;
cmd = [pf_create,' -i ',asciiname,' -f ',num2str(nf),' -o ',dat_pfile];
disp(cmd);
system(cmd);

disp('::: Deleting temporary file.')
delete(asciiname);
delete(ascpart);
end

[dp_path,dp_name,dp_ext] = fileparts(dat_pfile);
lab_pfile = [dp_path,'/',dp_name,'.lab',dp_ext];
if ~exist(lab_pfile,'file')
lab_asc = [lab_pfile,'.asc'];
if exist(lab_asc,'file'), delete(lab_asc); end;
isen = 0;
fid = fopen(src_list_file,'r');
while 1
    line = fgetl(fid);
    if ~ischar(line), break, end
    files = regexp(line,',','split');
    % write lab asc
    cmd = ['cat ',files{2},' | awk ''{ print "',num2str(isen),' " NR-1 " " $0 }'' >> ',lab_asc];
    disp(cmd);
    system(cmd);
    isen = isen + 1;
end
fclose(fid);

%% create label pfile from the ascii files
cmd = [pf_create,' -i ',lab_asc,' -l 1 -o ',lab_pfile];
disp(cmd);
system(cmd);
disp('::: Deleting temporary file.')
delete(lab_asc);
end

function [isen] = sub_pre_sbac(fn,asciiname,ascpart,isen,sr,mapping,b2,a2,t2)

disp(['Sentence: ',num2str(isen),' Preprocessing: ',fn])
[x] = audioread(fn,sr);
[ac] = cal_ac(x,sr,mapping,b2,a2,t2);
dlmwrite(ascpart,ac,'delimiter',' ');
cmd = ['cat ',ascpart,' | awk '' { print "',num2str(isen),' " NR-1 " " $0 }'' >> ',asciiname];
disp(cmd);
system(cmd);
isen = isen + 1;
